<template>
  <div class="lots-container">
    <ObTable
      ref="lotsTable"
      :columns="columns"
      :functional-panel="true"
      :show-add-button="isTenderEditable"
      :options-save-row="optionsTableSaveItem"
      :is-functional-group="false"
      :is-functional-sort="false"
      :remote-opt="{
        method: fetchLots,
        contentKey: 'lots'
      }"
      @add="onAdd"
      :class="{ 'table-editable': isTenderEditable }"
      data-qa="lotsTable"
      is-fixed-header
    >
      <template slot="extraFuncToPanel">
        <div class="lots-actions">
          <ObButton
            type="flat"
            v-if="isTenderEditable"
            class="lots-actions__edit-button"
            @click="openEditTable"
            label="Настроить таблицу..."
            data-qa="btnOpenEditTable"
          />

          <ObMenuDropdown
            class="lots-actions__export-excel"
            :items="excelDropdownItems"
            icon="excel"
          />
        </div>
      </template>

      <template
        slot="edit-row"
        slot-scope="{ data }"
      >
        <div class="edit-row">
          <button
            data-qa="btnEditLot"
            class="edit-row__button"
            title="Редактировать лот"
            @click="editLot(data)"
          >
            <span class="icon edit" />
          </button>

          <button
            data-qa="btnDeleteLot"
            class="edit-row__button"
            title="Удалить лот"
            @click="onLotDelete($event, data.item.uuid)"
          >
            <span class="icon close" />
          </button>
        </div>
      </template>
    </ObTable>

    <ObModal
      ref="addEditModal"
      :title="`${currentAction === 'edit' ? 'Редактирование лота' : 'Добавление лота'}`"
      size="large"
      data-qa="lotsAddEditModal"
    >
      <ModalAddEdit
        @save="onSave"
        :columns="columns"
        :data-source="selectedData"
        :ok-text="`${currentAction === 'edit' ? 'Сохранить' : 'Добавить'}`"
        :dropdown-menu="currentAction === 'edit' ? dropdownMenu : []"
      />
    </ObModal>

    <ObModal
      ref="editTableModal"
      title="Настройка таблицы"
      size="large"
      data-qa="lotsEditTableModal"
    >
      <ModalEditTable
        :settings-data="settingsData"
        @save="onEditTable"
      />
    </ObModal>

    <ObModal
      ref="settingsWarningModal"
      title="Удаление столбцов таблицы"
      size="medium"
      data-qa="lotsSettingsWarningModal"
    >
      <ModalSettingsWarning
        @save="saveTableSettings"
        :data-source="deleteColumnsData"
      />
    </ObModal>

    <ObModal
      ref="lotDeleteWarningModal"
      title="Удаление лота"
      size="medium"
      data-qa="lotsDeleteWarningModal"
    >
      <ModalLotDeleteWarning
        @save="deleteLot"
      />
    </ObModal>

    <ObModal
      ref="importFromExcelModal"
      title="Заполнение таблицы лотов в Excel"
      cancel-text="Отменить"
      size="medium"
      data-qa="importFromExcelModal"
    >
      <ModalImportFromExcel
        @close="closeImport"
        :tender-uuid="tenderInfo.uuid"
        :request-uuid="tenderInfo.requestUuid"
      />
    </ObModal>

    <SuccessExport
      ref="successExportModal"
      :data-source="exportResult"
    />
  </div>
</template>

<script>
  import ObTable from 'common-components/src/obComponents/obTable'
  import ObModal from 'common-components/src/obComponents/obModal'
  import ObButton from 'common-components/src/obComponents/obButton'
  import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown'

  import ModalAddEdit from './modal/addEdit.vue'
  import ModalEditTable from './modal/editTable.vue'
  import ModalSettingsWarning from './modal/settingsWarning.vue'
  import ModalLotDeleteWarning from './modal/lotDeleteWarning.vue'
  import ModalImportFromExcel from '../../../modal/importExcel.vue'

  import api from '@/api'
  import { uuid } from 'vue-uuid'
  import LotsTableMixin from '../mixins/lots-table'
  import ExportExcel from '../mixins/export-excel'

  export default {
    name: 'tender-tab-buyer-lots',
    components: {
      ObButton,
      ObTable,
      ObModal,
      ObMenuDropdown,
      ModalSettingsWarning,
      ModalLotDeleteWarning,
      ModalAddEdit,
      ModalEditTable,
      ModalImportFromExcel
    },
    mixins: [
      LotsTableMixin,
      ExportExcel
    ],
    data () {
      return {
        userType: 'buyer',
        currentAction: null,
        selectedData: {},
        settingsData: null,
        initialEnabledColumns: [],
        lotUuidToDelete: null,
        deleteColumnsData: {},
        dropdownMenu: [
          {
            title: 'Удалить',
            method: () => this.onLotDelete()
          }
        ]
      }
    },
    computed: {
      excelDropdownItems () {
        const items = [
          {
            title: 'Выгрузить заполненные данные в Excel...',
            method: this.exportToExcel
          }
        ]

        if (this.isTenderEditable) {
          items.unshift({
            title: 'Заполнить таблицу лотов в Excel...',
            method: this.showImportExcelModal
          })
        }

        return items
      }
    },
    async mounted () {
      this.isTenderEditable = await this.tenderInfo.status === 'DRAFT'
    },
    methods: {
      async openEditTable () {
        this.settingsData = await api.tenders.getLotsTableSettings(this.tenderInfo.requestUuid)

        this.initialEnabledColumns = this.settingsData.headers.reduce((filtered, field) => {
          // https://oboz.myjetbrains.com/youtrack/issue/TND-1069
          if (field.code === 'consent_desired_rate') {
            field.tooltip = 'Поставщик не сможет вводить значения ставки вручную, а сможет только соглашаться или не соглашаться с вашей целевой ставкой'
            field.description = 'Доступно, если у закупщика включен столбец «Целевая ставка»'
            field.isDisabled = !this.settingsData.headers.find(header => header.code === 'desired_rate').isSelected
          }

          if (field.isSelected) {
            filtered.push(field.uuid)
          }

          return filtered
        }, [])

        this.$refs.editTableModal.open()
      },
      onAdd () {
        this.selectedData = {}
        this.currentAction = 'add'

        this.$refs.addEditModal.open()
      },
      async onSave (data, reloadTable = true, types = this.initialFieldsTypes) {
        if (this.currentAction === 'edit') {
          const lotInfo = {
            tenderUuid: this.tenderInfo.uuid,
            lotValues: this.getLotValues(data, types, 'headerUuid')
          }

          try {
            await api.tenders.updateLot(this.selectedData.uuid, lotInfo)
            await this.updateTenderLots()

            if (reloadTable) {
              this.$refs.lotsTable.loadData({ init: true })
            }

            this.$notification({
              type: 'snackbars',
              message: 'Лот успешно отредактирован'
            })
          } catch (e) {
            this.$notification({
              type: 'system_notification_error',
              message: 'Ошибка редактирования лота'
            })
          }
        } else {
          const lotInfo = {
            tenderUuid: this.tenderInfo.uuid,
            requestUuid: this.tenderInfo.requestUuid,
            lotValues: this.getLotValues(data, types, 'headerUuid')
          }

          try {
            await api.tenders.createLot(uuid.v4(), lotInfo)
            await this.updateTenderLots()

            this.$refs.lotsTable.loadData({ init: true })

            this.$notification({
              type: 'snackbars',
              message: 'Лот успешно добавлен'
            })
          } catch (e) {
            this.$notification({
              type: 'system_notification_error',
              message: 'Ошибка добавления лота'
            })
          }
        }

        this.$refs.addEditModal.close()
      },
      async onEditTable () {
        // If lots array is empty due to 500 error
        if (typeof this.lotsData === 'undefined') {
          await this.saveTableSettings()

          return
        }

        // Подсчитываю кол-во столбцов, включенных при открытии настроек таблицы
        const disabledColumns = this.settingsData.headers.filter((header) => {
          return this.initialEnabledColumns.includes(header.uuid) && !header.isSelected
        })

        const disabledColumnsCountWithContent = disabledColumns.filter((column) => {
          return this.$refs.lotsTable.localItems.find(field => field[column.uuid])
        }).length

        this.deleteColumnsData.totalLotsCountToDelete = disabledColumns.length
        this.deleteColumnsData.lotsCountToDeleteWithContent = disabledColumnsCountWithContent

        if (disabledColumnsCountWithContent > 0) {
          this.showSettingsWarning()
        } else {
          await this.saveTableSettings()
        }
      },
      showSettingsWarning () {
        this.$refs.settingsWarningModal.open()
      },
      async saveTableSettings () {
        try {
          await api.tenders.updateLotsTableSettings(this.tenderInfo.requestUuid, {
            headers: this.settingsData.headers.filter((header) => {
              return header.isSelected
            }).map((header) => {
              return header.uuid
            })
          })

          this.$notification({
            type: 'snackbars',
            message: 'Настройки таблицы успешно сохранены'
          })

          this.isColumnsModified = false
          this.$refs.lotsTable.loadData({ init: true })
          this.$refs.settingsWarningModal.close()
          this.$refs.editTableModal.close()
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка сохранения настроек таблицы'
          })
        }
      },
      editLot (data) {
        this.selectedData = data.item
        this.currentAction = 'edit'

        this.$refs.addEditModal.open()
      },
      onLotDelete (e, lotUuid) {
        if (e) {
          e.stopPropagation()
        }

        this.lotUuidToDelete = lotUuid

        this.$refs.lotDeleteWarningModal.open()
      },
      async deleteLot () {
        this.$refs.lotDeleteWarningModal.close()

        let lotUuid = this.lotUuidToDelete

        if (!lotUuid) {
          lotUuid = this.selectedData.uuid

          this.$refs.addEditModal.close()
        }

        try {
          await api.tenders.deleteLot(this.tenderInfo.uuid, lotUuid)
          await this.updateTenderLots()

          this.$refs.lotsTable.loadData({ init: true })

          this.$notification({
            type: 'snackbars',
            message: 'Лот успешно удалён'
          })
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка удаления лота'
          })
        }
      },
      showImportExcelModal () {
        this.$refs.importFromExcelModal.open()
      },
      async closeImport () {
        // Чтобы обновить колонки, если пользователь запускает импорт,
        // а таблица уже была сформирована с определённым набором столбцов
        this.isColumnsModified = false

        this.$refs.lotsTable.loadData({ init: true })

        await this.updateTenderLots()

        this.$refs.importFromExcelModal.close()
      },
      async exportToExcel () {
        this.exportResult = await api.tendersExcels.RFQLots(this.tenderInfo.uuid, this.tenderInfo.requestUuid)
      }
    }
  };
</script>

<style lang="scss" scoped>
  @import '~common-components/src/assets/style/ob-style';
  @import '~common-components/src/static/css/variables';

  .lots-container {
    height: 100%;
  }

  .lots-actions {
    display: flex;
    align-items: center;

    &__edit-button {
      margin-right: 20px;
    }

    &__export-excel {
      z-index: 100; // Otherwise table head is over dropdown

      &.--opened::v-deep .icon::before {
        color: $cobalt;
      }
    }
  }

  .edit-row {
    display: grid;
    grid-gap: 7px;
    grid-auto-flow: column;
    align-items: center;
    margin-left: auto;

    &__button {
      border: none;
      background: none;
      color: $cobalt;
      font-size: 24px;
      cursor: pointer;
      display: inline-flex; // To remove whitespace
    }
  }

  .groups-row:not(:hover) .edit-row {
    opacity: 0;
  }

  ::v-deep {
    .text-gray {
      color: $color-grey-span;
    }

    .ob-table-inner.table-editable {
      th:last-child,
      td:last-child {
        position: sticky;
        right: 0;

        .td-container {
          opacity: 0;
        }
      }

      .data-row:hover {
        th:last-child,
        td:last-child {
          background: linear-gradient(270deg, $background-color-light 81.25%, rgba($background-color-light, 0) 100%);

          .td-container {
            opacity: 1;
          }
        }
      }
    }

    .table-header-required {
      color: $color-error;
      padding-left: 3px;
      font-size: 11px;

      &.disabled {
        color: $color-text-base;
      }
    }
  }
</style>
